let cube:Primitive;
let shader:Shader;
let camera:Camera;

const init = () => {
  print('Main invoked');

  cube = primitiveCreate();
  quadInit(cube, 0, -1, -1, 0, 0, 1, 1, 1, 1);

  camera = cameraCreate();

  shader = shaderCreate();
  assetShaderLoad(shader, "shaders/textured.vert", "shaders/textured.frag");

  shaderUse(shader);
  cameraLookAt(camera, 3,3,3, 0,0,0);
  cameraPerspective(camera, 45, 16/9, 0.01, 100);
}

const update = () => {
  shaderUse(shader);
  
  cameraLookAt(camera, 3,3,3, 0,0,0);
  cameraPerspective(camera, 45, 16/9, 0.01, 100);

  shaderUseCamera(shader, camera);
  shaderUsePosition(shader, 0,0,0, 0,0,0);
  primitiveDraw(cube, 0, -1);
}

const dispose = () => {
  cameraDispose(camera);
  shaderDispose(shader);
}